<!--未通过 failed-->
<template>
  <div class="app-container failed">
    <el-table v-loading="loading" border :data="studentinfoList" @selection-change="handleSelectionChange">
      <el-table-column label="姓名" align="left" prop="userName" />
      <el-table-column label="申请时间" align="left" prop="commitTime">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.commitTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="审批时间" align="left" prop="auditTime">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.auditTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="未通过原因" align="left" prop="opinions" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      layout="total, prev, pager, next, sizes, jumper"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改学生信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="学生ID" prop="joinStudentsId">
          <el-input v-model="form.joinStudentsId" placeholder="请输入学生ID" />
        </el-form-item>
        <el-form-item label="审核状态">
          <el-radio-group v-model="form.auditStatus">
            <el-radio label="1">请选择字典生成</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="学生卡图片" prop="card">
          <el-input v-model="form.card" placeholder="请输入学生卡图片" />
        </el-form-item>
        <el-form-item label="人脸信息图片" prop="faceImg">
          <el-input v-model="form.faceImg" placeholder="请输入人脸信息图片" />
        </el-form-item>
        <el-form-item label="部门id" prop="deptId">
          <el-input v-model="form.deptId" placeholder="请输入部门id" />
        </el-form-item>
        <el-form-item label="部门名称" prop="deptName">
          <el-input v-model="form.deptName" placeholder="请输入部门名称" />
        </el-form-item>
        <el-form-item label="创建人" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入创建人" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="cancel">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import { listStudentinfo,listStudentinfoByAudit, getStudentinfo, delStudentinfo, addStudentinfo, updateStudentinfo } from "@/api/laboratory/studentinfo";
  export default {
    name: "failed",
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 学生信息表格数据
        studentinfoList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          joinStudentsId: null,
          auditStatus: 'FAIL',
          card: null,
          faceImg: null,
          deptId: null,
          deptName: null,
          userId: null,
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {
        },
      };
    },
    created() {
      this.getList();
    },
    methods: {
      /** 查询学生信息列表 */
      getList() {
        this.loading = true;
        listStudentinfoByAudit(this.queryParams.auditStatus).then(response => {
          this.studentinfoList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          joinStudentsId: null,
          auditStatus: 0,
          card: null,
          faceImg: null,
          deptId: null,
          deptName: null,
          userId: null,
          remark: null,
          createBy: null,
          createTime: null,
          updateBy: null,
          updateTime: null
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.joinStudentsId)
        this.single = selection.length!==1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加学生信息";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const joinStudentsId = row.joinStudentsId || this.ids
        getStudentinfo(joinStudentsId).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改学生信息";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.joinStudentsId != null) {
              updateStudentinfo(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addStudentinfo(this.form).then(response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const joinStudentsIds = row.joinStudentsId || this.ids;
        this.$confirm('是否确认删除学生信息?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delStudentinfo(joinStudentsIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
      },
      /** 导出按钮操作 */
      handleExport() {
        this.download('laboratory/studentinfo/export', {
          ...this.queryParams
        }, `laboratory_studentinfo.xlsx`)
      }
    }
  };
</script>

<style scoped lang="scss">
  .failed {
    flex:1;
    display: flex!important;
    flex-direction: column;
  }
</style>

